Attribute VB_Name = "DiskWork"
Option Explicit
'******************************************************************************
'* Public Function SaveConsoleConfig(ByVal sFileName As String,
'*                                     aConsole As uConsoleData)as Boolean
'------------------------------------------------------------------------------
'*      AUTHOR:
'------------------------------------------------------------------------------
'*        DATE: 05/10/04
'------------------------------------------------------------------------------
'* DESCRIPTION:
'*
'* Function to Save Module Configuration.  Takes File Name as argument.
'* Saves Currently defined Module Configuration
'*
'*
'*
'******************************************************************************
Public Function SaveConsoleConfig(ByVal sFileName As String, aConsole() _
                                    As uConsoleData) As Boolean
Dim iNum As Integer, iTemp As Integer, iCount As Integer
Dim iLoop As Integer, iLoop2 As Integer
Dim answer As VbMsgBoxResult
Dim sErrMsg As String

    On Error GoTo ErrorMsg
    
'Check to see if file exists. If so, prompt user to replace.  If user wishes to
'replace delete existing file otherwise exit sub.
'------------------------------------------------------------------------------
    If Dir(sFileName) <> "" Then
        answer = MsgBox(sFileName & " exists." & vbCr & vbCr & "Do you wish to overwrite?", vbYesNo, "Save Inhibits")
        
        If answer <> vbYes Then
            Exit Function
        Else
            Kill sFileName
        End If
    End If
       
'Open Console Config Save file
'------------------------------------------------------------------------------
    iNum = FreeFile
    Open sFileName For Binary Shared As #iNum
    
'Save File Type
'------------------------------------------------------------------------------
    iTemp = gcCONSOLECONFIG
    Put #iNum, , iTemp
    
'Save Console Count
'------------------------------------------------------------------------------
    iCount = gcMAXCONSOLES
    Put #iNum, , iCount
    
'Save Version
'------------------------------------------------------------------------------
    iTemp = 1
    Put #iNum, , iTemp
    
'Save Integer Count
'------------------------------------------------------------------------------
    iTemp = 30
    Put #iNum, , iTemp
    
'Save Byte Count (Saved as integers for simplicity sake)
'------------------------------------------------------------------------------
    iTemp = 5
    Put #iNum, , iTemp
            
    For iLoop = 0 To iCount - 1

'Save Options
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).Fader
        iTemp = iTemp + (aConsole(iLoop).SourceSelect * 2)
        iTemp = iTemp + (aConsole(iLoop).CancelCue * 4)
        iTemp = iTemp + (aConsole(iLoop).CueType * 8)
        Put #iNum, , iTemp
        
'Save Options2
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).Options2
        Put #iNum, , iTemp
    
'Save Location
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).Location
        Put #iNum, , iTemp
    
'Save Mic
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).Mic
        Put #iNum, , iTemp
    
'Save Console Speakers
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).Speakers
        Put #iNum, , iTemp
    
'Save Talkback Source
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).TalkbackSrc
        Put #iNum, , iTemp
    
'Save Talkback Bus
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).TalkbackBus
        Put #iNum, , iTemp
    
'Save Cue Source
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).CueSrc
        Put #iNum, , iTemp
    
'Save Cue Speaker
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).CueSpeaker
        Put #iNum, , iTemp

'Save Cue Bus
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).CueBus
        Put #iNum, , iTemp

'Save Headphones Source
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).HeadphoneSrc
        Put #iNum, , iTemp

'Save Headphones Output
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).Headphones
        Put #iNum, , iTemp

'Save Headphones Bus
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).HeadphoneBus
        Put #iNum, , iTemp

'Save MeterBus(0)
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).MeterBus(0)
        Put #iNum, , iTemp

'Save MeterBus(1)
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).MeterBus(1)
        Put #iNum, , iTemp

'Save MeterBus(2)
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).MeterBus(2)
        Put #iNum, , iTemp

'Save MeterBus(3)
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).MeterBus(3)
        Put #iNum, , iTemp

'Save MeterBus(4)
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).MeterBus(4)
        Put #iNum, , iTemp

'Save MeterBus(5)
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).MeterBus(5)
        iTemp = IIf(iTemp = 0, gcNOTDEFINED, iTemp)
        Put #iNum, , iTemp

'Save MeterBus(6)
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).MeterBus(6)
        iTemp = IIf(iTemp = 0, gcNOTDEFINED, iTemp)
        Put #iNum, , iTemp

'Save MeterBus(7)
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).MeterBus(7)
        iTemp = IIf(iTemp = 0, gcNOTDEFINED, iTemp)
        Put #iNum, , iTemp

'Save TimerStart
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).TimerStart
        Put #iNum, , iTemp

'Save TimerStop
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).TimerStop
        Put #iNum, , iTemp

'Save TimerHold
'------------------------------------------------------------------------------
'        iTemp = aConsole(iLoop).TimerHold - 1
        iTemp = gcNOTDEFINED
        Put #iNum, , iTemp

'Save TimerReset
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).TimerReset
        Put #iNum, , iTemp

'Save TimerExtReset
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).TimerExtReset
        Put #iNum, , iTemp

'Save AuxInt1
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).AuxInt1
        iTemp = IIf(iTemp = 0, gcNOTDEFINED, iTemp)
        Put #iNum, , iTemp

'Save AuxInt2
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).AuxInt2
        iTemp = IIf(iTemp = 0, gcNOTDEFINED, iTemp)
        Put #iNum, , iTemp

'Save AuxInt3
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).AuxInt3
        iTemp = IIf(iTemp = 0, gcNOTDEFINED, iTemp)
        Put #iNum, , iTemp

'Save AuxInt4
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).AuxInt4
        iTemp = IIf(iTemp = 0, gcNOTDEFINED, iTemp)
        Put #iNum, , iTemp

'Save DimValue
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).DimValue
        Put #iNum, , iTemp

'Save AuxByte1
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).AuxByte1
        Put #iNum, , iTemp

'Save AuxByte2
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).AuxByte2
        Put #iNum, , iTemp

'Save AuxByte3
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).AuxByte3
        Put #iNum, , iTemp

'Save AuxByte4
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).AuxByte4
        Put #iNum, , iTemp

    Next

'Close the file
'------------------------------------------------------------------------------
    Close #iNum
    
'Normal Exit to Procedure
'------------------------------------------------------------------------------
    Exit Function

'Error - Log error and exit procedure
'------------------------------------------------------------------------------
ErrorMsg:
    sErrMsg = "Error Saving Console Configuration"
'    Call frmMain.ErrorMessage(sErrMsg, "File Error")

'Close the database, recordset & file
'------------------------------------------------------------------------------
    Close #iNum
    
End Function
'******************************************************************************
'* Public Function SaveConsoleConfig(ByVal sFileName As String,
'*                                     aConsole As uConsoleData)as Boolean
'------------------------------------------------------------------------------
'*      AUTHOR:
'------------------------------------------------------------------------------
'*        DATE: 05/10/04
'------------------------------------------------------------------------------
'* DESCRIPTION:
'*
'* Function to Save Module Configuration.  Takes File Name as argument.
'* Saves Currently defined Module Configuration
'*
'*
'*
'******************************************************************************
Public Function SaveConsoleInfo(ByVal sName As String, aConsole() As uConsoleInfo, iCount As Integer) As Boolean
Dim iNum As Integer, iTemp As Integer, iSize As Integer, iButCount As Integer
Dim iLoop As Integer, iLoop2 As Integer, iLoop3 As Integer
Dim lTemp As Long
Dim tDelete As Boolean
Dim answer As VbMsgBoxResult
Dim sErrMsg As String, sTempString As String

    On Error GoTo ErrorMsg

    For iLoop = 1 To iCount
        
        If gvaConsoleInfo(iLoop).ConsoleName <> "" Then
            sTempString = gvsPath & gvaConsoleInfo(iLoop).ConsoleName & ".cns"
        Else
        
            sTempString = gvsPath & sName
            sTempString = sTempString & " Console " & iLoop & ".cns"
        End If
        
        If Dir(sTempString) <> "" Then
            If tDelete = False Then
                answer = MsgBox(sTempString & " exists." & vbCr & vbCr & "Do you wish to overwrite?", vbYesNo, "Save Inhibits")
        
                If answer <> vbYes Then
                    Exit Function
                Else
                    tDelete = True
                    Kill sTempString
                End If
            Else
                Kill sTempString
            End If
        End If
        
'Open Console Config Save file
'------------------------------------------------------------------------------
        iNum = FreeFile
        Open sTempString For Binary Shared As #iNum
    
'Save File Type
'------------------------------------------------------------------------------
        iTemp = gcCONSOLECONTROLMODULE
        Put #iNum, , iTemp
        
'Save Version
'------------------------------------------------------------------------------
        iTemp = 1
        Put #iNum, , iTemp
        
'Save Console Size
'------------------------------------------------------------------------------
        iSize = aConsole(iLoop).ConsoleSize
        Put #iNum, , iSize
    
'Save Console Number
'------------------------------------------------------------------------------
        iTemp = aConsole(iLoop).ConsoleNumber - 1
        Put #iNum, , iTemp
    
        For iLoop2 = 1 To iSize
            iTemp = aConsole(iLoop).ConsoleStrip(iLoop2).Type
            Put #iNum, , iTemp
        
'            iTemp = aConsole(iLoop).ConsoleStrip(iloop2).InDisplay
            iTemp = gcNOTDEFINED
            Put #iNum, , iTemp
'            iTemp = aConsole(iLoop).ConsoleStrip(iloop2).OutDisplay
            iTemp = gcNOTDEFINED
            Put #iNum, , iTemp
'            iTemp = aConsole(iLoop).ConsoleStrip(iloop2).SourceOptions
            iTemp = 0
            Put #iNum, , iTemp
'            iTemp = aConsole(iLoop).ConsoleStrip(iloop2).DestinationOptions
            iTemp = 0
            Put #iNum, , iTemp
'            iTemp = aConsole(iLoop).ConsoleStrip(iloop2).ExternalSwitcher
            iTemp = gcNOTDEFINED
            Put #iNum, , iTemp
'            iTemp = aConsole(iLoop).ConsoleStrip(iloop2).AuxChan1
            iTemp = gcNOTDEFINED
            Put #iNum, , iTemp
'            iTemp = aConsole(iLoop).ConsoleStrip(iloop2).AuxChan2
            iTemp = gcNOTDEFINED
            Put #iNum, , iTemp
'            iTemp = aConsole(iLoop).ConsoleStrip(iloop2).AuxChan3
            iTemp = gcNOTDEFINED
            Put #iNum, , iTemp
'            iTemp = aConsole(iLoop).ConsoleStrip(iloop2).AuxChan4
            iTemp = gcNOTDEFINED
            Put #iNum, , iTemp
'            iTemp = aConsole(iLoop).ConsoleStrip(iloop2).AuxChan5
            iTemp = gcNOTDEFINED
            Put #iNum, , iTemp
'            iTemp = aConsole(iLoop).ConsoleStrip(iloop2).AuxChan6
            iTemp = gcNOTDEFINED
            Put #iNum, , iTemp
'            iTemp = aConsole(iLoop).ConsoleStrip(iloop2).AuxChan7
            iTemp = gcNOTDEFINED
            Put #iNum, , iTemp
'            iTemp = aConsole(iLoop).ConsoleStrip(iloop2).AuxChan8
            iTemp = gcNOTDEFINED
            Put #iNum, , iTemp
'            iTemp = aConsole(iLoop).ConsoleStrip(iloop2).MixMinusOn
            iTemp = gcNOTDEFINED
            Put #iNum, , iTemp
'            iTemp = aConsole(iLoop).ConsoleStrip(iloop2).MixMinusOff
            iTemp = gcNOTDEFINED
            Put #iNum, , iTemp
'            iTemp = aConsole(iLoop).ConsoleStrip(iloop2).Location
            iTemp = gcNOTDEFINED
            Put #iNum, , iTemp
        
            lTemp = aConsole(iLoop).ConsoleStrip(iLoop2).MFDOptions
            Put #iNum, , lTemp
        
            iButCount = aConsole(iLoop).ConsoleStrip(iLoop2).ButtonCount
            Put #iNum, , iButCount
        
            For iLoop3 = 0 To 31
                
                If iLoop3 < iButCount Then
                    iTemp = aConsole(iLoop).ConsoleStrip(iLoop2).Buttons(iLoop3).Type
                Else
                    iTemp = 255
                End If
                Put #iNum, , iTemp
            
                If iLoop3 < iButCount Then
                    iTemp = aConsole(iLoop).ConsoleStrip(iLoop2).Buttons(iLoop3).Item
                Else
                    iTemp = gcNOTDEFINED
                End If
                Put #iNum, , iTemp
            
            Next
        
        Next
        
        Close
    Next

    Exit Function

'Error - Log error and exit procedure
'------------------------------------------------------------------------------
ErrorMsg:
    sErrMsg = "Error Saving Module Configuration"
'    Call frmMain.ErrorMessage(sErrMsg, "File Error")

'Close the database, recordset & file
'------------------------------------------------------------------------------
    Close
    
End Function



