Attribute VB_Name = "Variables"
'All variables MUST be declared.
'------------------------------------------------------------------------------
Option Explicit

Public gvsPath As String

Type uInAlphas
    Channel As Integer
    Link As Integer
    Hidden As Integer
    Label As String
    Note As String
    Location As Integer                 'Location of this channel
    LocalAlpha As String                'Local Alpha Label
    Type As Integer                     'Source Type
    IFB As Integer                      'Attributes for this channel
    Timer As Integer                    'Attributes for this channel
    MixMinus As Integer                 'Attributes for this channel
    Mute As Integer                     'Attributes for this channel
    GPIType As Integer                     'Attributes for this channel
    GPOType As Integer                     'Attributes for this channel
    AssocChan As Integer                'Associated Output Channel for IFB
    AssocRelayOn As Integer             'Associated Relay - On
    AssocRelayOff As Integer            'Associated Relay - Off
    AssocOptoOn As Integer              'Associated Opto - On
    AssocOptoOff As Integer             'Associated Opto - Off
    AssocOptoCough As Integer           'Associated Opto - Cough
    AssocOptoCueOn As Integer           'Associated Opto - Cue On
    AssocOptoCueOff As Integer          'Associated Opto - Cue Off
    
End Type

Public gvaInAlphas() As uInAlphas

Type uOutAlphas
    Channel As Integer
    Link As Integer
    Hidden As Integer
    Label As String
    Note As String
    Location As Integer                 'Location of this channel
    LocalAlpha As String                'Local Alpha Label
    Type As Integer                     'Source Type
    Mute As Integer
    Fader As Integer
    Switch As Integer
    AuxId As Integer                    'Channel Auxiliary ID
    AuxChan1 As Integer                 'Associated Input
    AuxChan2 As Integer                 'Associated Output
    AssocRelay As Integer               'Associated Relay
    RelayControl As Byte                'Relay Control
    RelayType As Byte                   'Relay Control
    MixMinusSource As Integer           'Mix Minus Source
    MixMinusMasterOut As Integer        'Mix Minus Master Out
    
End Type

Public gvaOutAlphas() As uOutAlphas

Type uMiscAlphas
    Channel As Integer
    Label As String
    Note As String

End Type

Public gvaLocationAlphas(gcMAXLOCATIONS) As uMiscAlphas
Public gvaConsoleAlphas(gcMAXCONSOLES) As uMiscAlphas
Public gvaRelayAlphas() As uMiscAlphas

Type uOptos
    Channel As Integer
    Label As String
    Note As String
    Type As Integer
    Salvo As Integer
    Input As Integer
    Output As Integer
    Relay As Integer

End Type

Public gvaOptoAlphas() As uOptos

Type uOptoRelay                         'Opto Relay Sets
    Number As Integer
    Label As String                     'Label for Set
    Opto(4) As Integer                  'Array of Optos
    Relay(4) As Integer                 'Array of Relays
    Notes As String
End Type

Public gvaOptoRelay(gcMAXCONSOLES) As uOptoRelay

'Rubicon Console Data Type
'------------------------------------------------------------------------------
Type uConsoleData
'    Options As Integer                  'Console Options
    SourceSelect As Integer             'Source Select Lock Out Option
    CancelCue As Integer                'Cancel Cue Option
    CueType As Integer                  'Cue Type Option
    Fader As Integer                    'Fader Start Option
    Options2 As Integer                 'Console Options2 - Online Console Options
    Location As Integer                 'Console Location
    Mic As Integer                      'Console Mic
    Speakers As Integer                 'Console Control Room Speakers
    TalkbackSrc As Integer              'Talkback Source
    TalkbackBus As Integer              'Fixed Gain Talkback Bus
    CueSrc As Integer                   'DSP Cue Feed
    CueBus As Integer                   'Fixed Gain Cue Bus
    CueSpeaker As Integer               'Cue Bus with Level Control
    HeadphoneSrc As Integer             'Console Control Room Headphones Source
    HeadphoneBus As Integer             'Console Control Room Guest Headphones
    Headphones As Integer               'Console Control Room Headphones
    MeterBus(7) As Integer              'Meter Bus 1-8
    TimerStart As Integer               'Timer Start Relay
    TimerStop As Integer                'Timer Stop Relay
    TimerHold As Integer                'Timer Hold Relay
    TimerReset As Integer               'Timer Reset Relay
    TimerExtReset As Integer            'Timer External Reset Relay
    AuxInt1 As Integer                  'Aux Integer 1
    AuxInt2 As Integer                  'Aux Integer 2
    AuxInt3 As Integer                  'Aux Integer 3
    AuxInt4 As Integer                  'Aux Integer 4
    DimValue  As Byte                   'Speaker Fim Value in dB
    AuxByte1 As Byte                    'Aux Byte 1
    AuxByte2 As Byte                    'Aux Byte 2
    AuxByte3 As Byte                    'Aux Byte 3
    AuxByte4 As Byte                    'Aux Byte 4
End Type

Public gvaConsoleData(gcMAXCONSOLES) As uConsoleData

Type uConsoleButtons
    Type As Integer
    Item As Integer
End Type

'Address Version/Status Data Type - used in Frame Data Type
'------------------------------------------------------------------------------
Type uAddressStatus                     'Data Structure for each Address
'    State As Byte                       'Address State
'    Status As Byte                      'Address Status
    Type As Integer                     'Address Type/Module ID
    SType As String                     'Module Type
'    Version As String                   'Version
    SingleOutChan As Integer            'Channel 1 - Single Source
    SingleInChan As Integer             'Channel 2 - Single Destination
    Opto As Integer                     'First Opto Number
    Relay As Integer                    'First Relay Number
    InDisplay As Integer                'Source Display List
    OutDisplay As Integer               'Destination Display List
    ButTemplate As Integer              'Button Template used by this Address
    AddressOption As Integer            'Address Options
    MFDOptions As Long                  'MFD Options for console
    SourceOptions As Byte               'Source Channel Option Bits
    DestinationOptions As Byte          'Destination Channel Option Bits (Mode)
    ExternalSwitcher As Integer         '
    AuxChan1 As Integer                 '
    AuxChan2 As Integer                 '
    AuxChan3 As Integer                 '
    AuxChan4 As Integer                 '
    AuxChan5 As Integer                 '
    AuxChan6 As Integer                 '
    AuxChan7 As Integer                 '
    AuxChan8 As Integer                 '
    MixMinusOn As Integer               'MixMinus OnLine Bus
    MixMinusOff As Integer              'MixMinus OffLine Bus
    Location As Integer                 'Physical location id
    ButtonCount As Integer              'Number of buttons
    Buttons(32) As uConsoleButtons
End Type

Type uConsoleInfo
    ConsoleSize As Integer
    ConsoleNumber As Integer
    ConsoleName As String
    ConsoleStrip(40) As uAddressStatus
    Frame As Integer
    Slot As Integer
    Port As Integer
End Type

Public gvaConsoleInfo(gcMAXCONSOLES) As uConsoleInfo

'Switcher Slot Data Type
'------------------------------------------------------------------------------
Type uSlot                              'Data Structure for each slot
'    State As Byte                       'Slot State
    PortCount As Byte                   'Port Count
'    Port(gcMAXPORT) As uPort            'Port Array
'    Device(gcMAXDEVICE) As uDevice      'Device Array
'    DeviceCount As Byte
'    Status As Byte                      'Slot Status
    InChan As Integer                   'First Source Chan - Both for I/O
    OutChan As Integer                  'First Dest Chan
    Opto As Integer                     'First Opto Number
    Relay As Integer                    'First Relay Number
    Type As Integer                     'Module Type/Model ID
    SType As String                     'Module Type as a string
'    Version As String                   'Version
End Type

'Switcher Frame Data Type
'------------------------------------------------------------------------------
Type uFrame                             'Data Structure for each frame
'    State As Byte                       'Frame State
'    Status As Byte                      'Frame Status
    SlotCount As Byte                   'Slot Count
    Slot(gcMAXSLOT) As uSlot            'Slot Array
    Type As Integer                     'Frame type
    Location As Integer                 'Location number
End Type

Public gvaFrame(gcMAXFRAME) As uFrame
